import { DynamicModule, MiddlewareConsumer, NestModule } from '@nestjs/common';
import { I18nAsyncOptions, I18nOptions } from './interfaces/i18n-options.interface';
import { HttpAdapterHost, ModuleRef } from '@nestjs/core';
export declare class I18nModule implements NestModule {
    private readonly httpAdapterHost;
    private readonly i18nOptions;
    private readonly moduleRef;
    constructor(httpAdapterHost: HttpAdapterHost, i18nOptions: I18nOptions, moduleRef: ModuleRef);
    configure(consumer: MiddlewareConsumer): MiddlewareConsumer | void;
    static forRoot(options: I18nOptions): DynamicModule;
    static forRootAsync(options: I18nAsyncOptions): DynamicModule;
    private static createAsyncOptionsProvider;
    private static createAsyncTranslationProvider;
    private static sanitizeI18nOptions;
}
