"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const i18n_constants_1 = require("../i18n.constants");
let I18nLanguageMiddleware = class I18nLanguageMiddleware {
    constructor(i18nOptions) {
        this.i18nOptions = i18nOptions;
    }
    use(req, res, next) {
        try {
            let language = null;
            for (const resolver of this.i18nOptions.resolvers) {
                language = resolver.resolve(req);
                if (language !== undefined) {
                    break;
                }
            }
            req.i18nLang = language || this.i18nOptions.fallbackLanguage;
        }
        catch (e) {
            console.log(e);
        }
        next();
    }
};
I18nLanguageMiddleware = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(i18n_constants_1.I18N_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], I18nLanguageMiddleware);
exports.I18nLanguageMiddleware = I18nLanguageMiddleware;
//# sourceMappingURL=i18n-language-middleware.js.map