"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class HeaderResolver {
    constructor(keys = ['accept-language']) {
        this.keys = keys;
    }
    resolve(req) {
        let lang;
        for (const key of this.keys) {
            if (req.headers[key] !== undefined) {
                lang = req.headers[key];
                break;
            }
        }
        return lang;
    }
}
exports.HeaderResolver = HeaderResolver;
//# sourceMappingURL=header.resolver.js.map